#include "Program.h"
#include <GL/glut.h>

using namespace std;

GLUI* glui;
Program* program;

static void HandleDisplay () { program->HandleDisplay(); }
static void HandleReshape (int w, int h) { program->HandleReshape(w, h); }
static void HandleKeyboard (unsigned char key, int x, int y) { program->HandleKeyboard(key, x, y); }
static void HandleSpecialKey(int key, int x, int y) { program->HandleSpecialKey(key, x, y); }
static void HandleMouse(int button, int state, int x, int y) { program->HandleMouse(button, state, x, y); }
static void HandleMouseMotion(int x, int y) { program->HandleMouseMotion(x, y); }
static void HandleIdle (void) { program->HandleIdle(); }

int main(int argc, char* argv[])
{
	glutInit (&argc, argv);
	glutInitDisplayMode (GLUT_RGB | GLUT_DOUBLE | GLUT_DEPTH);
	glutInitWindowSize (640, 480);
	glutInitWindowPosition (0,0);

	int winId = glutCreateWindow("Complex Logarithmic Mapping");

	program = new Program(winId);
	glui = GLUI_Master.create_glui("GLUI");
	program->InitGlui(glui);

	// Register Callback functions for GLUT
	
	glutDisplayFunc (HandleDisplay);
	glutKeyboardFunc (HandleKeyboard);
	glutMouseFunc (HandleMouse);
	glutMotionFunc (HandleMouseMotion);
	glutSpecialFunc (HandleSpecialKey);
	glutReshapeFunc (HandleReshape);

	//GLUI_Master.set_glutKeyboardFunc(HandleKeyboard);
	GLUI_Master.set_glutIdleFunc(HandleIdle);
	//glutIdleFunc(HandleIdle);

	glutMainLoop ();

	return 0;
}


