#pragma once

#include <cstdlib>
#include <GL/glut.h>
#include <complex>
#include <vector>
#include <iostream>

//HACK
#include "Texture.h"

const double PI = 3.14159;

typedef std::complex<double> Complex;
typedef struct TexturedGrid {Complex complex; bool isCut; double uCoordinate; double vCoordinate; } TexturedGrid;
typedef std::vector<TexturedGrid> ComplexVector;
typedef std::vector<ComplexVector> ComplexGrid;

typedef ComplexGrid::const_iterator GridIteratorConst;
typedef ComplexVector::const_iterator VectorIteratorConst;

class LinearGrid 
{
public:
	//LinearGrid(const unsigned int _gridWidth, const unsigned int _gridHeight);
	LinearGrid(const unsigned int _gridSize);
	~LinearGrid(void);

	//HACK
	void Draw();

	unsigned int GetSize() const {return gridSize; }

	const Texture* GetTexture() const;

	const ComplexGrid GetGrid() const { return linearGrid; }

private:
	void SetVector(TexturedGrid _tg);
	void SetGrid(void);

private:
	ComplexVector linearVector;	// row vector
	ComplexGrid linearGrid;	// row/col-vector

	unsigned int gridSize;
	static const double eps;

	Texture* texture;
};
