#pragma once

#define GLUT_DISABLE_ATEXIT_HACK
#include <windows.h>
#include <GL/glut.h>
#include <complex>
#include <vector>
#include <cmath>

typedef std::complex<double> Complex;
typedef std::vector<Complex*>::iterator CItr;

// Abstract base class for MeshGrids
class MeshGrid
{
public:
	virtual void Draw() = 0;

public:
	std::vector<Complex*> complexMesh;
	std::vector<Complex*>::iterator itr;

	static const double POS_PI;
	static const double NEG_PI;
	static const unsigned int GRID_RES;
	static const unsigned int GRID_INTERVAL;
	static const double leftRange;
	static const double rightRange;
	static const double interval;
	static const float eps;

};
