#pragma once

#include "LinearGrid.h"
#include "RootGrid.h"
#include "Texture.h"
#include "glui.h"

#define GRID_WIDTH 70
#define GRID_HEIGHT 70

#define ESC 27

class Program
{
public:
	Program(int _windowId);
	~Program();
	Program(const Program& other) {}

	void InitGlui(GLUI* _glui);

	void HandleReshape (int w, int h);
	void HandleDisplay (void);
	void HandleKeyboard (unsigned char key, int x, int y);
	void HandleSpecialKey(int key, int x, int y);
	void HandleMouse(int button, int state, int x, int y);
	void HandleMouseMotion(int x, int y);
	void HandleIdle(void);

private:	// private methods
	void InitProjection();
	void UpdateState();

private:	// private member
	GLenum polygonMode;

	int windowWidth, windowHeight;

	LinearGrid* linearGrid;
	RootGrid* rootGrid;

	int mouseButton;
	int oldX, oldY;

	float rootRes;

private:
	GLUI *glui;
	int windowId;

	int gluiWireframe;
	int gluiGridSize;

	int fileNumber;

	GLUI_RadioGroup * gluiRadioGroup;
};

